import * as tslib_1 from "tslib";
import { validate2 } from "@hpcc-js/ddl-shim";
import { Table } from "@hpcc-js/dgrid";
import { SplitPanel } from "@hpcc-js/phosphor";
import { JSONEditor } from "./JSONEditor";
import "../src/DDLEditor.css";
var DDLEditor = (function (_super) {
    tslib_1.__extends(DDLEditor, _super);
    function DDLEditor() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.summary = "0 Errors";
        _this._ddlEditor = new JSONEditor().on("changes", function (changes) {
            _this.checkSyntax();
        });
        _this._errorTable = new Table()
            .columns(["dataPath", "keyword", "message", "params"]);
        return _this;
    }
    DDLEditor.prototype.ddl = function (_) {
        if (!arguments.length)
            return this._ddlEditor.json();
        this._ddlEditor.json(_);
        this.checkSyntax();
        return this;
    };
    DDLEditor.prototype.checkSyntax = function () {
        try {
            var json = this.ddl();
            try {
                var d = validate2(json);
                if (d.success) {
                    this._errorTable.data([]);
                }
                else {
                    this._errorTable.data(d.errors.map(function (error) { return [error.dataPath, error.keyword, error.message, JSON.stringify(error.params)]; }));
                }
            }
            catch (e) {
                this._errorTable.data([["", "Validation Failed", "", ""]]);
            }
        }
        catch (e) {
            this._errorTable.data([["", "Invalid JSON", "", ""]]);
        }
        if (this._renderCount) {
            this._errorTable.lazyRender();
        }
    };
    DDLEditor.prototype.enter = function (domNode, element) {
        _super.prototype.enter.call(this, domNode, element);
        this
            .addWidget(this._ddlEditor)
            .addWidget(this._errorTable);
    };
    DDLEditor.prototype.update = function (domNode, _element) {
        _super.prototype.update.call(this, domNode, _element);
    };
    return DDLEditor;
}(SplitPanel));
export { DDLEditor };
DDLEditor.prototype._class += " codemirror_DDLEditor";
//# sourceMappingURL=DDLEditor.js.map