(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "./Editor"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var Editor_1 = require("./Editor");
    var JSONEditor = (function (_super) {
        tslib_1.__extends(JSONEditor, _super);
        function JSONEditor() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        JSONEditor.prototype.options = function () {
            return tslib_1.__assign({}, _super.prototype.options.call(this), {
                mode: "application/json"
            });
        };
        JSONEditor.prototype.json = function (_) {
            if (!arguments.length)
                return JSON.parse(this.text());
            this.text(JSON.stringify(_, null, "\t"));
            return this;
        };
        return JSONEditor;
    }(Editor_1.Editor));
    exports.JSONEditor = JSONEditor;
    JSONEditor.prototype._class += " codemirror_JSONEditor";
});
//# sourceMappingURL=JSONEditor.js.map